"use client";
'use strict';

var React = require('react');
var tinyInvariant = require('./external/tiny-invariant/dist/esm/tiny-invariant.js');
var constant = require('./constant.js');
var useRollbar = require('./useRollbar.js');
var utils = require('./utils.js');

function useRollbarCaptureEvent(metadata) {
  var level = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : constant.LEVEL_INFO;
  tinyInvariant.default(utils.isValidLevel(level), "".concat(level, " is not a valid level setting for Rollbar"));
  var rollbar = useRollbar.useRollbar();
  React.useEffect(function () {
    rollbar.captureEvent(metadata, level);
  }, [metadata, level, rollbar]);
}

exports.useRollbarCaptureEvent = useRollbarCaptureEvent;
//# sourceMappingURL=useRollbarCaptureEvent.js.map
